require 'fast_helper'
require 'background_jobs/configuration'
require 'background_jobs/queue_service'
require 'background_jobs/strategies/sidekiq/setup'

describe 'Sidekiq' do

  let(:sidekiq_fake_job) { Class.new }

  let(:clock) { stub('clock') }
  let(:clock_schedule) { stub('clock_schedule') }

  before do
    BackgroundJobs.configure do |config|
      config.strategy = 'sidekiq'
    end
  end

  context 'with schedule' do
    let(:scheduled_set) { stub('scheduled_set') }

    it 'should schedule the job if schedule is set' do
      BackgroundJobs::QueueService.expects(:enqueue).with(:fake_job, [], :in => 60*10, :unique => true)

      BackgroundJobs.register_job :fake_job, :core, sidekiq_fake_job, :schedule => 60*10
    end
  end

  it 'should not schedule the job if schedule not set' do
    BackgroundJobs::QueueService.expects(:enqueue).never

    BackgroundJobs.register_job :fake_job, :core, sidekiq_fake_job
  end
end