require 'fast_helper'
require 'background_jobs/job_factory'

module BackgroundJobs
  describe JobFactory do
    before do
      BackgroundJobs.register_job :foo, :bar, Imitate.mock('Foo')
    end

    describe '.build' do
      context 'for existing job' do
        it 'should create job instance' do
          JobFactory.build(:foo).should be_instance_of Foo
        end
      end

      context 'for not-existing job' do
        it 'should throw an exception' do
          expect { JobFactory.build(:not_existing_job) }.to raise_error("Unknown job 'not_existing_job'!")
        end
      end
    end
  end
end