require 'fast_helper'
require 'background_jobs/job'

describe BackgroundJobs::Job do
  before do
    Imitate.mock 'Airbrake' do
      def self.notify(param); end
    end
  end

  let(:job) { BackgroundJobs::Job.new }

  subject { job }

  describe '#perform' do
    it { expect { subject.perform }.to raise_error NotImplementedError }
  end

  describe '#id=' do
    before { job.id = 123 }

    it { subject.instance_variable_get(:@id).should eq 123 }
  end

  describe '#execute' do
    it { expect { subject.execute }.to raise_error NotImplementedError }
  end

  describe 'error' do
    let(:exception) { stub('exception') }

    before do
      Airbrake.expects(:notify).with(exception)
    end

    it { job.error('whatever', exception) }
  end
end
