require 'fast_helper'
require 'background_jobs/queue_service'

module BackgroundJobs
  describe QueueService do
    let(:job_type) { :fix_all_bugs_while_we_sleep }

    let(:priority) { 1 }

    let(:data) { [1, 2, 3, 'foo', {1 => :uno}] }

    let(:job_id) { 'job_id' }

    let(:expected_queue_params) { data }

    let(:strategy) { stub('strategy') }

    describe '.enqueue' do
      let(:delay) { stub('delay') }

      before do
        QueueService.stubs(:generate_job_id).returns(job_id)

        JobQueueFactory.expects(:build).returns(strategy)

        strategy.expects(:enqueue).with(
          job_type, job_id, expected_queue_params, :priority => priority, :in => delay
        )
      end

      subject { QueueService.enqueue(job_type, data, :priority => priority, :in => delay) }

      it { should == job_id }
    end
  end
end
