require 'fast_helper'
require 'background_jobs/strategies/direct_call/job_queue'

module BackgroundJobs
  module DirectCall
    describe JobQueue.new do
      let(:type) { :foo }

      let(:priority) { 1 }

      let(:attrs) { [10..10, :foo => :bar] }

      let(:job) { stub('job') }

      let(:job_id) { 123 }

      describe '.enqueue' do
        it 'should create a job and execute it' do
          JobFactory.expects(:build).with(type, attrs).returns(job)
          job.expects(:execute)

          JobQueue.new.enqueue(type, job_id, attrs)
        end
      end
    end
  end
end