require 'fast_helper'
require 'background_jobs/strategies/sidekiq/job_queue'

module BackgroundJobs
  module Sidekiq
    describe JobAdapter.new do
      let(:job) { stub('job', :execute => true) }

      describe '#peform' do
        subject { JobAdapter.new.perform('foo', '1', :bar, :baz, 'range:[10,1000]') }
        
        before { JobFactory.stubs(:build).returns(job) }

        it 'should call job factory with appropriate job type and attributes' do
          JobFactory.expects(:build).with(:foo, [:bar, :baz, 10..1000]).returns(job)
          job.expects(:id=).with(1)

          subject
        end

        it 'should call job perform with no attributes' do
          job.expects(:execute)
          job.expects(:id=).with(1)

          subject
        end
      end
    end
  end
end